
(* Texteditor Modul zu WDRSIM.PAS (Version 05.01.88) *)

procedure neu(var zeiger : zeilenzeiger; var platz : integer);
  var
    z : integer;

  begin
    z := 0;
    while (freizeilen[z] = false) and (z < programmlaenge) do
      begin
        z := succ(z);
      end;
    zeiger := z;
    freizeilen[z] := false;
    platz := pred(platz);
  end;

procedure wegdamit(zeiger : zeilenzeiger; var platz : integer);
  begin
    freizeilen[zeiger] := true;
    platz := succ(platz);
  end;

const
  edspace = ' ';
  edzeilenlaenge : integer = 79;

type
  eddatenstring = string[80];
  edworkstring = string[80];
  edcharset = set of char;

procedure beep;
  begin
    write(piep);
  end;

function Conststr(c : char; n : integer) : eddatenstring;
  var
    s : eddatenstring;

  begin
    if n < 0 then n:= 0;
    s[0] := chr(n);
    fillchar(s[1],n,c);
    conststr := s
  end;

procedure InputStr(var S     : edworkstring;
                       L,X,Y : Integer;
                       Term  : edCharSet;
                   var TC    : Char    );

var
  P : Integer;
  Ch : Char;

begin
  GotoXY(X,Y); Write(S,ConstStr(edspace,L - Length(S)));
  P := 0;
  repeat
    GotoXY(X + P,Y); Read(kbd,Ch);
    if ibm then
      begin
        if ch = esc then
          begin
            read(kbd,ch);
            case ch of
              'K' : ch := ^S;
              'M' : ch := ^D;
              'G' : ch := ^A;
              'O' : ch := ^F;
              'S' : ch := ^G;
              'H' : ch := ^E;
              'P' : ch := ^X
              else ch := esc;
            end;
          end;
      end;
    case Ch of
      #32..#126 : if P < L then
                  begin
                    if Length(S) = L then Delete(S,L,1);
                    P := succ(P);
                    Insert(Ch,S,P);
                    Write(Copy(S,P,L));
                  end
                  else Beep;
      ^S        : if P > 0 then
                    P := pred(P)
                  else Beep;
      ^D        : if P < Length(S) then
                    P := succ(P)
                  else Beep;
      ^A        : P := 0;
      ^F        : P := Length(S);
      ^G        : if P < Length(S) then
                  begin
                    Delete(S,P + 1,1);
                    Write(Copy(S,P + 1,L),edspace);
                  end;
      ^H,#127   : if P > 0 then
                  begin
                    Delete(S,P,1);
                    Write(^H,Copy(S,P,L),edspace);
                    P := pred(P);
                  end
                  else Beep;
      ^T        : begin
                    Write(ConstStr(edspace,Length(S) - P));
                    Delete(S,P + 1,L);
                  end;
    else
      if not (Ch in Term) then Beep;
    end;  {of case}
  until Ch in Term;
  P := Length(S);
  GotoXY(X + P + 1,Y);
  Write('':L - P);
  TC := Ch;
end;

procedure bearbeitetext(textname : namentyp;
                       var textanfang, fehlerposition : zeilenzeiger;
                       var platz : integer);
  const
    anfangszeile : integer = 2;
    letztezeile : integer = 23;

  var
    k, zeileaufschirm : integer;
    arbeitsdaten : zeilentyp;
    bearbeitungfertig : boolean;
    neuezeile, textzeile, zwischenzeile, textende, schirmanfang : zeilenzeiger;
    ch : char;

procedure fuelleschirm(schirmzeile : zeilenzeiger);
  var
    aktuellezeile : zeilentyp;
    k : integer;

  begin
    for k := anfangszeile to letztezeile do
      begin
        if schirmzeile <> nix then
          begin
            aktuellezeile := prtext[schirmzeile].zeile;
            schirmzeile := prtext[schirmzeile].naechster;
          end
        else
          begin
            aktuellezeile := '';
          end;
        gotoxy(1,k);
        write(aktuellezeile);
        clreol;
      end;
  end;


  begin                 (* bearbeitetext *)
                        (* Bildschirm vollschreiben, bzw. loeschen *)
        clrscr;
        gotoxy(1,1);
        lowvideo;
        write('Zeile :      Frei :                      Text : ');
        normvideo;
        write(' ',textname);
        gotoxy(1,24);
        if ibm then write('Cursorbewegungen: Pfeiltasten')
        else write('Cursorbewegungen: ^S,^D,^E,^X');
        gotoxy(60,24);
        if ibm then write('Ende: ^KD');
        if apple then write('Ende: <ESC>');
        if cpm then write('Ende mit ^KD, <Esc>');
        k := 1;
        textende := textanfang;
        while prtext[textende].naechster <> nix do
          begin
            textende := prtext[textende].naechster;
          end;
        if fehlerposition = nix then
          begin
            textzeile := textanfang;
          end
        else
          begin
            textzeile := fehlerposition;
            while textzeile <> textanfang do
              begin
                k := succ(k);
                textzeile := prtext[textzeile].letzter;
              end;
            textzeile := fehlerposition;
          end;
        schirmanfang := textzeile;
        fuelleschirm(schirmanfang);
        zeileaufschirm := anfangszeile;
        bearbeitungfertig := false;
        repeat
          gotoxy(8,1);
          write(k:4,' ');
          gotoxy(20,1);
          write(platz-1:4,' ');
          arbeitsdaten := prtext[textzeile].zeile;
          if ibm then
            inputstr(arbeitsdaten,edzeilenlaenge,1,
                   zeileaufschirm,[^E,^K,^M,^N,^X,^Y],ch)
          else
            inputstr(arbeitsdaten,edzeilenlaenge,1,
                   zeileaufschirm,[^E,^K,^M,^N,^X,^Y,esc],ch);
          prtext[textzeile].zeile := arbeitsdaten;
          case ch of
            ^E : begin
                   if textzeile = textanfang then
                     begin
                       beep;
                     end
                   else
                     begin
                       k := pred(k);
                       textzeile := prtext[textzeile].letzter;
                       if zeileaufschirm > anfangszeile then
                         begin
                           zeileaufschirm := pred(zeileaufschirm);
                         end
                       else
                         begin
                           schirmanfang := prtext[schirmanfang].letzter;
                           fuelleschirm(schirmanfang);
                         end;
                     end;
                 end;
            ^M : begin
                   if platz > 1 then
                     begin
                       zeileaufschirm := succ(zeileaufschirm);
                       if zeileaufschirm > letztezeile then
                         begin
                           schirmanfang := prtext[schirmanfang].naechster;
                           zeileaufschirm := letztezeile;
                         end;
                       k := succ(k);
                       if textzeile = textende then
                         begin
                           neu(zwischenzeile,platz);
                           prtext[zwischenzeile].zeile := '';
                           prtext[zwischenzeile].naechster := nix;
                           prtext[zwischenzeile].letzter := textzeile;
                           prtext[textzeile].naechster := zwischenzeile;
                           textzeile := zwischenzeile;
                           textende := textzeile;
                         end
                       else
                         begin
                           neu(zwischenzeile,platz);
                           prtext[zwischenzeile].zeile := '';
                           prtext[zwischenzeile].naechster :=
                                                   prtext[textzeile].naechster;
                           prtext[zwischenzeile].letzter := textzeile;
                           prtext[textzeile].naechster := zwischenzeile;
                           textzeile := prtext[zwischenzeile].naechster;
                           prtext[textzeile].letzter := zwischenzeile;
                           textzeile := zwischenzeile;
                         end;
                       fuelleschirm(schirmanfang);
                     end
                   else
                     begin
                       beep;
                     end;
                 end;
            ^X : begin
                   if textzeile = textende then
                     begin
                       beep;
                     end
                   else
                     begin
                       zeileaufschirm := succ(zeileaufschirm);
                       textzeile := prtext[textzeile].naechster;
                       k := succ(k);
                       if zeileaufschirm > letztezeile then
                         begin
                           schirmanfang := prtext[schirmanfang].naechster;
                           fuelleschirm(schirmanfang);
                           zeileaufschirm := letztezeile;
                         end;
                     end;
                 end;
            ^N : begin
                   if platz > 1 then
                     begin
                       neu(zwischenzeile,platz);
                       prtext[zwischenzeile].zeile := '';
                       prtext[zwischenzeile].naechster := textzeile;
                       prtext[zwischenzeile].letzter := prtext[textzeile].letzter;
                       prtext[textzeile].letzter := zwischenzeile;
                       if textzeile = textanfang then
                         begin
                           textanfang := zwischenzeile;
                           schirmanfang := textanfang;
                         end
                       else
                         begin
                           textzeile := prtext[zwischenzeile].letzter;
                           prtext[textzeile].naechster := zwischenzeile;
                         end;
                       textzeile := zwischenzeile;
                       fuelleschirm(schirmanfang);
                     end
                   else
                     begin
                       beep;
                     end;
                 end;
            ^Y : begin
                   if textanfang = textende then
                     begin
                       prtext[textzeile].zeile := '';
                     end
                   else
                     begin
                       if (textzeile <> textanfang) and (textzeile <> textende) then
                         begin
                           zwischenzeile := prtext[textzeile].letzter;
                           prtext[zwischenzeile].naechster :=
                                               prtext[textzeile].naechster;
                           zwischenzeile := prtext[textzeile].naechster;
                           prtext[zwischenzeile].letzter := prtext[textzeile].letzter;
                         end
                       else
                         begin
                           if textzeile = textanfang then
                             begin
                               textanfang := prtext[textzeile].naechster;
                               prtext[textanfang].letzter := nix;
                               zwischenzeile := textanfang;
                               schirmanfang := textanfang;
                             end;
                           if textzeile = textende then
                             begin
                               textende := prtext[textzeile].letzter;
                               prtext[textende].naechster := nix;
                               zwischenzeile := textende;
                               k := pred(k);
                               zeileaufschirm := pred(zeileaufschirm);
                             end;
                         end;
                       wegdamit(textzeile,platz);
                       textzeile := zwischenzeile;
                       fuelleschirm(schirmanfang);
                     end;
                 end;
            ^K : begin
                   read(kbd,ch);
                   bearbeitungfertig := (upcase(ch) = 'D') or (ch = ^D);
                 end;
            esc: bearbeitungfertig := true;
          end;  (* case *)
        until bearbeitungfertig;
        fehlerposition := nix;
  end;

procedure schreibetext(dateiname : namentyp;
                       var textanfang,fehlerposition : zeilenzeiger;
                       var platz : integer; var gespeichert : boolean);
  begin
    if (textanfang <> nix) then
      begin
        bearbeitetext(dateiname,textanfang,fehlerposition,platz);
        gespeichert := false;
      end
    else
      begin
        writeln;
        lowvideo;
        writeln('Vor der Textbearbeitung erst einen Namen festlegen !',piep);
        normvideo;
        taste;
      end;
  end;