
program WDR_Simulation;

(*$C-*)

const
  datum = '03.03.1989';
  besitzer = ' DATANorf - Hard- und Software, Am Alten Bach 14a, 4040 Neuss 21,  02107/70627';
  version = '(Version fuer  CP/M-80)';
  appleversion = '(Version Apple-CP/M)';
  ibmversion = '(Version IBM, MS-DOS)';
  kopf1 =
'          WDR - Computer - Simulation   ';
  kopf2 =
'                              (C) Burkhard John                     ';

                               (* Systemabhaengige Teile zur Steuerung *)
                               (* Apple *)
  apple = false;
  applepause = 1;
  appleausgang = $E050;
  appleeingang = $E060;
  appletrigger = $E070;
  applebitrein1 = 1;
  applebitrein2 = 2;
  applebitrein3 = 3;
  applepaddle   = 7;            (* Anpassung fuer Eingang 4 *)
  applebit = 128;
  appleshift0 = 12;
  appleshift1 = 13;
  appleclock0 = 14;
  appleclock1 = 15;
  appledaten0 = 10;
  appledaten1 = 11;

                               (* CP/M Computer allgemein *)
  cpm = false;
  eingangsport = $F0;          (* Eingangsport *)
  ausgangsport = $F1;          (* Ausgangsport *)
  kontrollport = $F2;          (* Portbaustein *)
  kontrollwort = $FF;          (* initialisieren, falls noetig *)
  bitrein1 = 1;
  bitrein2 = 2;
  bitrein3 = 4;
  bitrein4 = 8;

  ibm = true;
                               (* IBM Druckerport *)
  ibmbitrein1 = 128;                (* Bitpositionen der Eingangsbits *)
  ibmbitrein2 = 32;                (* bei IBM polaritaet der bits beachten *)
  ibmbitrein3 = 16;                (* siehe wdrsim1.inc *)
  ibmbitrein4 = 8;
  ibminvers1 = true;
  ibminvers2 = false;
  ibminvers3 = false;
  ibminvers4 = false;
  ibmeingangsport : integer = 889;          (* Eingangsport *)
  ibmausgangsport : integer = 888;          (* Ausgangsport *)

  zeilenlaenge = 80;
  namenlaenge = 12;
  esc = #27;
  piep = ^G;
  formfeed = #12;
  hilfename = 'HANDBUCH.WDR';
  ioportdatei = 'IOPORT.WDR';
  kommentar = '*';
  nix = -1;
  programmlaenge = 257;
  menuex = 20;
  menuey = 6;
  opcodezahl = 13;
  opcodes : array[0..opcodezahl,0..1] of string[5] =
            (('NOPO ','OOOO'),('LD ','OOO*'),('LDC ','OO*O'),
             ('AND ','OO**'),('ANDC ','O*OO'),('OR ','O*O*'),
             ('ORC ','O**O'),('XNOR ','O***'),('STO ','*OOO'),
             ('STOC ','*OO*'),('IEN ','*O*O'),('OEN ','*O**'),
             ('JMP ','**OO'),('SKZ ','***O'));

  adressen : array[0..7] of string[3] = ('OOO','OO*','O*O','O**',
                                         '*OO','*O*','**O','***');

  schirmbild : array[1..23] of string[80] = (
' WDR - Computer - Simulation',
' (C) Burkhard John und DATANorf - Hard- und Software, Neuss',
'',
'   O  O  O     O O O O O O O    O O O O O O O O     OOOO      OOO',
'   T  E  D     7 6 5 4 3 2 1    7 6 5 4 3 2 1 0',
'   a  R  a       Eingaenge         Ausgaenge       Befehl    Adresse',
'   k     t',
'   t     a',
'',
'',
'   Eingangsschalter      Taktart     IEN  OEN         Interface-Steuerung',
'    4   3   2   1',
'    O   O   O   O        Handtakt     O    O                  AUS',
'',
'============================================================================',
'',
'Tastenfunktionen:',
'<H> Handtakt                <L> Langsamtakt                 <S> Schnelltakt',
'<T> Handtakt weiterschalten, <+> <-> Geschwindigkeit im Langsamtakt aendern',
'<P> Spurng zum Programmanfang                <R> Ruecksetzen aller Register',
'Interface-Steuerung AUS: <1> <2> <3> <4> Eingangsschalter umschalten',
'                        <ESC> Ende der Simulation',
'');
  maxmenue = 10;
  menuedaten : array[1..maxmenue] of string[19] =
             ('< W >   Name',
              '< E >   Bearbeiten',
              '< C >   Uebersetzen',
              '< R >   Starten',
              '< S >   Speichern',
              '< L >   Laden',
              '< P >   Drucken',
              '< H >   Hilfe',
              '< I >   Interface',
              '< Q >   Beenden');


type
  namentyp = string[namenlaenge];
  zeilentyp = string[zeilenlaenge];
  zeilenzeiger = integer;
  textzeile = record
                   letzter : zeilenzeiger;
                   naechster : zeilenzeiger;
                   zeile : zeilentyp;
                   op : char;
                   adresse : char;
                 end;

var
  auswahl : char;
  textanfang, fehlerposition : zeilenzeiger;
  prtext : array[0..programmlaenge] of textzeile;
  freizeilen : array[0..programmlaenge] of boolean;
  zeile : textzeile;
  platz : integer;
  dateiname : namentyp;
  ende : boolean;
  leerlauf : boolean;
  gespeichert : boolean;
  aussen : boolean;


(*$IWDRSIM0.INC*)
(*$IWDRED.INC*)
(*$IPERIPHER.INC*)
(*$IWDRSIM1.INC*)
(*$IWDRSIM2.INC*)
(*$IWDRSIM3.INC*)


begin
  initialisiereports(ibmausgangsport,ibmeingangsport);
  for textanfang := 0 to programmlaenge do
    begin
      freizeilen[textanfang] := true;
      prtext[textanfang].zeile := '';
      prtext[textanfang].naechster := nix;
      prtext[textanfang].letzter := nix;
    end;
  textanfang := nix;
  fehlerposition := nix;
  platz := programmlaenge;
  ende := false;
  aussen := false;
  leerlauf := false;
  gespeichert := false;
  dateiname := '';
  repeat
    menu(auswahl,leerlauf,dateiname,aussen);
    leerlauf := false;
    case auswahl of
      'H' : hilfe;
      'L' : laden(textanfang,dateiname,gespeichert,platz);
      'C' : programmpruefen(textanfang,fehlerposition);
      'S' : speichern(textanfang,dateiname,gespeichert);
      'P' : printtext(dateiname,textanfang);
      'R' : starten(textanfang,fehlerposition,aussen);
      'E' : schreibetext(dateiname,textanfang,fehlerposition,platz,gespeichert);
      'W' : arbeitstext(textanfang,dateiname,gespeichert,platz);
      'Q' : programmende(textanfang,dateiname,gespeichert,ende);
      'I' : aussen := not aussen;
      else begin
             leerlauf := true;
             write(piep);
           end;
    end; (* case *)
  until ende;
  clrscr;
end.

