
(* Porzeduren zu WDRSIM.PAS .. Simulation 03.03.89 *)

procedure starten(var textanfang, fehlerposition : zeilenzeiger;
                  aussen : boolean);
  const
    anfangstempo = 1;
    deltat = 5;

  type
    takttyp = (handtakt, langsamtakt, schnelltakt);

  const
    taktname : array[handtakt..schnelltakt] of string[8] =
                  ('Handtakt','Langsam ','Schnell ');

  var
    aktuellezeile : zeilenzeiger;
    z, befehl : integer;
    tastenwert : char;
    ergebnis : boolean;
    takt : boolean;
    data : boolean;
    taktart : takttyp;
    ien, oen : boolean;
    adr : integer;
    fertig : boolean;
    tempo : integer;
    opcodenummer : integer;
    skzgewesen : integer;

  procedure schreibebit(x,y : integer; wert : boolean);
    begin
      gotoxy(x,y);
      if wert then write('*') else write('O');
    end;

  procedure erstellebild;
    begin
      schreibebit(4,4,takt);
      schreibebit(7,4,ergebnis);
      schreibebit(10,4,data);
      for z := 1 to 7 do schreibebit(30-2*z,4,eingabe[z]);
      for z := 0 to 7 do schreibebit(47-2*z,4,ausgabe[z]);
      gotoxy(53,4);
      write(opcodes[ord(prtext[aktuellezeile].op),1]);
      write('      ',adressen[adr]);
      gotoxy(53,5);
      write(opcodes[ord(prtext[aktuellezeile].op),0]);
      gotoxy(64,5);
      write(adr);
      schreibebit(39,13,ien);
      schreibebit(44,13,oen);
    end;


  procedure bearbeitetasten;

    procedure eingangtaste(nummer:integer);
      begin
        tasten[nummer] := not(tasten[nummer]);
        if not aussen then eingabe[nummer] := tasten[nummer];
        schreibebit(21-4*nummer,13,tasten[nummer]);
      end;

    begin
      read(kbd,tastenwert);
      tastenwert := upcase(tastenwert);
      case tastenwert of
        '1' : eingangtaste(1);
        '2' : eingangtaste(2);
        '3' : eingangtaste(3);
        '4' : eingangtaste(4);
        'H' : taktart := handtakt;
        'S' : begin
                taktart := schnelltakt;
                tastenwert := 'T';
              end;
        'L' : begin
                taktart := langsamtakt;
                tastenwert := 'T';
              end;
        'R' : begin
                ergebnis := false;
                data := false;
                for z := 0 to 7 do ausgabe[z] := false;
                takt := true;
                ien := false;
                oen := false;
              end;
        'P' : aktuellezeile := textanfang;
        esc : fertig := true;
        '+' : begin
                tempo := tempo - deltat;
                if tempo < 1 then tempo := 1;
              end;
        '-' : tempo := tempo + deltat;
      end;  (* case *)
      if not aussen then
        for z := 1 to 7 do schreibebit(30-2*z,4,eingabe[z]);
      gotoxy(26,13);
      write(taktname[taktart]);
    end;


              (* Simulation durchfuehren *)
  begin
    if textanfang = nix then
      begin
        error;
      end
    else
      begin
        if prtext[textanfang].naechster <> nix then
        begin
        programmpruefen(textanfang,fehlerposition);
        if fehlerposition = nix then
          begin
            for z := 0 to 7 do
              begin
                eingabe[z] := false;
                ausgabe[z] := false;
              end;
            for z := 1 to 4 do tasten[z] := false;
            nachdraussen := 0;
            vondraussen := 0;
            ergebnis := false;
            ien := false;
            oen := false;
            takt := true;
            data := false;
            taktart := handtakt;
            fertig := false;
            skzgewesen := 0;
            tempo := anfangstempo;
            clrscr;
            for z := 1 to 23 do writeln(schirmbild[z]);
            gotoxy(69,1);
            write(datum);
            gotoxy(63,13);
            if aussen then write('EIN') else write('AUS');
            repeat
              aktuellezeile := textanfang;
              while prtext[aktuellezeile].op = kommentar do
                aktuellezeile := prtext[aktuellezeile].naechster;
              while (aktuellezeile <> nix) and (not fertig) do
                begin

                    (*  Befehlsnummer holen *)

               
                  val(prtext[aktuellezeile].adresse,adr,z);
                  befehl := ord(prtext[aktuellezeile].op);

                  if (not aussen) or (taktart <> schnelltakt) then
                    erstellebild;

                  if keypressed then bearbeitetasten;

                  if aussen then
                    begin
                      holeinterfacedaten;
                      gibanperipherieaus;
                    end;

                    (* Befehle ausfuehren *)

              if skzgewesen = 0 then
                begin
                  if not takt then
                    begin
                      case befehl of
                        1 : begin  (* ld *)
                              if ien then ergebnis := data;
                            end;
                        2 : begin  (* ldc *)
                              if ien then ergebnis := not data;
                            end;
                        3 : begin  (* and *)
                              if ien then ergebnis := ergebnis and data;
                            end;
                        4 : begin  (* andc *)
                             if ien then ergebnis:=ergebnis and (not data);
                            end;
                        5 : begin  (* or *)
                              if ien then ergebnis := ergebnis or data;
                            end;
                        6 : begin  (* orc *)
                              if ien then
                                ergebnis := ergebnis or (not data)
                              else ergebnis := true;
                            end;
                        7 : begin  (* xnor *)
                              if ien then
                                ergebnis := not(ergebnis xor data)
                              else ergebnis := true;
                            end;
                        8..9 : if oen then ausgabe[adr] := data;
                      end;    (* case *)
                    end
                  else
                    begin
                      case befehl of
                        1..7 : data := eingabe[adr];
                        8 : begin  (* sto *)
                              if oen then data := ergebnis;
                            end;
                        9 : begin  (* stoc *)
                              if oen then data := not ergebnis;
                            end;
                        10: begin  (* ien *)
                              ien := ergebnis;
                            end;
                        11: begin  (* oen *)
                              oen := ergebnis;
                            end;
                        13: begin  (* skz *)
                              if not ergebnis then
                                begin
                                  skzgewesen := 2;
                                end;
                            end;
                      end; (* case *)
                    end;
                end;

                                    (* Datenspeicher aktualisieren *)

                  for z := 5 to 7 do eingabe[z] := ausgabe[z];
                  eingabe[0] := ergebnis;

                  case taktart of
                    schnelltakt : ;
                    langsamtakt : delay(tempo);
                    handtakt    : begin
                                    repeat
                                      bearbeitetasten;
                                    until fertig or (tastenwert = 'T');
                                  end;
                  end; (* case *)

                  takt := not takt;

                                    (* naechsten Befehl holen *)

                  if takt then
                    begin
                      if (befehl = 12) and (skzgewesen = 0) then
                        begin
                          aktuellezeile := textanfang;
                        end
                      else
                        begin
                          aktuellezeile := prtext[aktuellezeile].naechster;
                        end;
                      while prtext[aktuellezeile].op = kommentar do
                        aktuellezeile := prtext[aktuellezeile].naechster;
                      if skzgewesen > 0 then skzgewesen := pred(skzgewesen);
                    end;


                end; (* while aktuellezeile <> nix *)
            until fertig;
            if aussen then
              begin
                for z := 0 to 7 do ausgabe[z] := false;
                gibanperipherieaus;
              end;
          end;
        end
        else
          begin
            writeln;
            writeln('Erst ein Programm schreiben !',piep);
            taste;
          end;
      end;
  end;
