
procedure printtext(dateiname : namentyp; textanfang : zeilenzeiger);
  var
    tzeile : zeilenzeiger;
    zeilennummer : integer;

  begin
    if textanfang = nix then
      begin
        error;
      end
    else
      begin
        writeln;
        write('Das Programm wird gedruckt.');
        writeln(lst,'Programm : ',dateiname);
        writeln(lst);
        tzeile := textanfang;
        zeilennummer := 1;
        while tzeile <> nix do
          begin
            writeln(lst,zeilennummer:5,' ',prtext[tzeile].zeile);
            tzeile := prtext[tzeile].naechster;
            zeilennummer := succ(zeilennummer);
          end;
        write(formfeed);
        taste;
      end;
  end;

procedure speichern(textanfang : zeilenzeiger; textname : namentyp;
                    var gespeichert : boolean);
  var
    altername : zeilentyp;
    datei : text;
    zeile : zeilenzeiger;

  begin
    if textanfang = nix then
      begin
        error;
      end
    else
      begin
        if pos('.',textname) = 0 then
          begin
            altername := copy(textname,1,namenlaenge - 4) + '.BAK';
          end
        else
          begin
            altername := copy(textname,1,pos('.',textname)-1) + '.BAK';
          end;
        assign(datei,altername);
        (*$I-*)
        reset(datei);
        (*$I+*)
        if ioresult = 0 then erase(datei);
        assign(datei,textname);
        (*$I-*)
        reset(datei);
        (*$I+*)
        if ioresult = 0 then
          begin
            close(datei);
            rename(datei,altername);
          end;
        assign(datei,textname);
        rewrite(datei);
        zeile := textanfang;
        writeln;
        write('Das Programm wird gespeichert.');
        repeat
          writeln(datei,prtext[zeile].zeile);
          zeile := prtext[zeile].naechster;
        until zeile = nix;
        close(datei);
      end;
    gespeichert := true;
  end;


procedure laden(var textanfang : zeilenzeiger; textname : namentyp;
                var gespeichert : boolean; var platz : integer);

  var
    datei : text;
    zwischen, zeile : zeilenzeiger;
    zeichen : char;

  begin
    if textanfang = nix then
      begin
        error;
      end
    else
      begin
        assign(datei,textname);
        (*$I-*)
        reset(datei);
        (*$I+*)
        if ioresult <> 0 then
          begin
            writeln;
            lowvideo;
            writeln('Den Programmtext gibt es nicht ! ',piep);
            normvideo;
            taste;
          end
        else
          begin
            if not eof(datei) then
              begin
                writeln;
                write('Das Programm ',textname,' wird geladen.');
                while prtext[textanfang].naechster <> nix do
                  begin
                    zwischen := prtext[textanfang].naechster;
                    wegdamit(textanfang,platz);
                    textanfang := zwischen;
                  end;
                zwischen := textanfang;
                while not eof(datei) do
                  begin
                    readln(datei,prtext[zwischen].zeile);
                    neu(zeile,platz);
                    prtext[zwischen].naechster := zeile;
                    prtext[zeile].letzter := zwischen;
                    zwischen := zeile;
                  end;
                zwischen := prtext[zeile].letzter;
                wegdamit(zeile,platz);
                prtext[zwischen].naechster := nix;
              end;
            close(datei);
          end;
        gespeichert := true;
      end;
  end;


procedure arbeitstext(var textanfang : zeilenzeiger;
                      var dateiname : namentyp;
                      var gespeichert : boolean;
                      var platz : integer);

  var
    hilfszeiger : zeilenzeiger;
    datei : text;
    zwischenzeiger, zeile : zeilenzeiger;
    antwort : char;
    z : integer;

  begin
    if (textanfang <> nix) and (not gespeichert) then
      begin
        writeln;
        write('Den Text ',dateiname,' speichern (J) ? ',piep);
        read(kbd,antwort);
        antwort := upcase(antwort);
        if (antwort = 'S') or (antwort = 'J') then
          begin
            speichern(textanfang, dateiname, gespeichert);
          end;
        while textanfang <> nix do
          begin
            hilfszeiger := prtext[textanfang].naechster;
            wegdamit(textanfang,platz);
            textanfang := hilfszeiger;
          end;
      end;
    writeln;
    dateiname := '';
    write('Name des Programms : ');
    readln(dateiname);
    for z  := 1 to length(dateiname) do
      begin
        dateiname[z] := upcase(dateiname[z]);
      end;
    if pos('.',dateiname) <> 0 then
      begin
        dateiname := copy(dateiname,1,namenlaenge);
      end;
    if (pos('.',dateiname) = 0) and (dateiname <> '') then
      begin
        dateiname := copy(dateiname,1,namenlaenge - 4) + '.WDR';
      end;
    gespeichert := true;
    if dateiname <> '' then
      begin
        neu(textanfang,platz);
        prtext[textanfang].naechster := nix;
        prtext[textanfang].letzter := nix;
        prtext[textanfang].zeile := '';
        assign(datei,dateiname);
        (*$I-*)
        reset(datei);
        (*$I+*)
        if ioresult = 0 then
          begin
            zwischenzeiger := textanfang;
            while not eof(datei) do
              begin
                readln(datei,prtext[zwischenzeiger].zeile);
                neu(zeile,platz);
                prtext[zwischenzeiger].naechster := zeile;
                prtext[zeile].letzter := zwischenzeiger;
                zwischenzeiger := zeile;
              end;
            zwischenzeiger := prtext[zeile].letzter;
            wegdamit(zeile,platz);
            prtext[zwischenzeiger].naechster := nix;
            close(datei);
          end;
      end;
  end;
